#ifndef COLORUTIL_H
#define COLORUTIL_H
#include <exec/types.h>
#include <math.h>

float ComponentToFraction(UWORD comp);
UWORD FractionToComponent(float frac);

void Separate(UWORD col, UWORD *r, UWORD *g, UWORD *b);
void SeparateFractions(UWORD col, float *r, float *g, float *b);

UWORD Combine(UWORD r, UWORD g, UWORD b);
UWORD CombineFractions(float r, float g, float b);

void Represent(UWORD col, char * dest);

UWORD Blend(UWORD col0, UWORD col1, float bias);

BOOL SampleGradient(UWORD col0, UWORD col1, UWORD nrSamples, UWORD * samples);
void PrintGradient(UWORD * colors, UWORD nrColors);
void MirrorGradient(UWORD * src, UWORD * dst, UWORD nrColors);
// dst has src appended to it -- so it should be big enough
void AppendGradient(UWORD * dst, UWORD * src, UWORD nrDst, UWORD nrSrc, BOOL skip1);

void TestConversion();
void TestRepresent();
void TestGradient();
#endif